#include "ImagiBOT.h"
#include "ImagiBOT_Servo.h"

	Servo sA[4];
	Servo sB[2];
			
	float VelocidadActualFloat[2];
	float Incremento0=1.0; float Incremento1=1.0;
	float RetardoSimultaneo=0.0;
	float PasosSimultaneos=0.0;
	int PreVelDer=0;int PreVelIzq=0; int PreDuracion=0;
	float VelFinal[2];
	float Aceleracion[2];
    //Servo sB;
    //Servo sC;
    //Servo sD;

//Servo180::Servo180(){
//	PosicionActual=90;
//}

void Servo180::init(){
	sA[0].attach(Servo180A);
	sA[1].attach(Servo180B);
	sA[2].attach(Servo180C);
	sA[3].attach(Servo180D);
	PosicionActual[0]=90;
	PosicionActual[1]=90;
	PosicionActual[2]=90;
	PosicionActual[3]=90;
}

void Servo180::Posicion(int Motor,int Pos,int Duracion){
	int Diferencia;
	int Incremento=1;
	if(Pos<0){Pos=0;}
	if(Pos>180){Pos=180;}
	
	if(Duracion==0){
		PosicionActual[Motor]=Pos;
		sA[Motor].write(Pos);
	}else{
		if(Duracion<1){Duracion=1;}
		if(Duracion>10){Duracion=10;}
		Diferencia=Pos-PosicionActual[Motor];
		if(Diferencia<0){Incremento= -1;Diferencia= abs(Diferencia);}
		for(int i=PosicionActual[Motor];i != Pos ; i += Incremento){
			sA[Motor].write(i);	
			delay(Duracion*1000/Diferencia);
		}
		PosicionActual[Motor]=Pos;
	}
}

void Servo180::Simultaneo(int Pos0,int Pos1, int Pos2, int Pos3,int Duracion){
	float Diferencia0; float Diferencia1; float Diferencia2; float Diferencia3;
	float Incremento0=1.0; float Incremento1=1.0; float Incremento2=1.0; float Incremento3=1.0;
	float Pasos=100.0;
	float PosicionActualFloat[4];
	PosicionActualFloat[0]=PosicionActual[0];
	PosicionActualFloat[1]=PosicionActual[1];
	PosicionActualFloat[2]=PosicionActual[2];
	PosicionActualFloat[3]=PosicionActual[3];
	if(Pos0<0){Pos0=0;}	if(Pos0>180){Pos0=180;}
	if(Pos1<0){Pos1=0;}	if(Pos1>180){Pos1=180;}
	if(Pos2<0){Pos2=0;}	if(Pos2>180){Pos2=180;}
	if(Pos3<0){Pos3=0;}	if(Pos3>180){Pos3=180;}
	
	if(Duracion<1.0){Duracion=1.0;}
	if(Duracion>10.0){Duracion=10.0;}
	Diferencia0=Pos0-PosicionActualFloat[0];Incremento0=Diferencia0/Pasos;
	Diferencia1=Pos1-PosicionActualFloat[1];Incremento1=Diferencia1/Pasos;
	Diferencia2=Pos2-PosicionActualFloat[2];Incremento2=Diferencia2/Pasos;
	Diferencia3=Pos3-PosicionActualFloat[3];Incremento3=Diferencia3/Pasos;
	//if(Diferencia<0){Incremento= -1;Diferencia= abs(Diferencia);}
	for(int i=0;i < Pasos ; i++){
		sA[0].write(PosicionActualFloat[0]);	
		sA[1].write(PosicionActualFloat[1]);	
		sA[2].write(PosicionActualFloat[2]);	
		sA[3].write(PosicionActualFloat[3]);	
		PosicionActualFloat[0] += Incremento0;
		PosicionActualFloat[1] += Incremento1;
		PosicionActualFloat[2] += Incremento2;
		PosicionActualFloat[3] += Incremento3;
		delay(Duracion*1000/Pasos);
	}
	sA[0].write(Pos0);	
	sA[1].write(Pos1);	
	sA[2].write(Pos2);	
	sA[3].write(Pos3);	
	PosicionActual[0]=Pos0;
	PosicionActual[1]=Pos1;
	PosicionActual[2]=Pos2;
	PosicionActual[3]=Pos3;
}


int Servo180::obtenerPosicion(int Motor){
	//luzSemaforo = luzSemaforo + 25;
	return PosicionActual[Motor];
}



void Servo360::init(){
	sB[0].attach(Servo360D);
	sB[1].attach(Servo360I);
	VelocidadActual[0]=90;
	VelocidadActual[1]=90;
}

		
		
void Servo360::Velocidad(int Motor,int vel, int Aceleracion){
	int Diferencia;
	int Incremento=1;
	if(vel< -100){vel= -100;}
	if(vel>100){vel=100;}
	vel=map(vel,-100,100,0,180);
	
	if(Aceleracion==0){
		VelocidadActual[Motor]=vel;
		sB[Motor].write(vel);
	}else{
		if(Aceleracion<1){Aceleracion=1;} if(Aceleracion>10){Aceleracion=10;}
		Diferencia=vel-VelocidadActual[Motor];
		if(Diferencia<0){Incremento= -1;Diferencia= abs(Diferencia);}
		for(int i=VelocidadActual[Motor];i != vel ; i += Incremento){
			sB[Motor].write(i);	
			delay(Aceleracion*1000/Diferencia);
		}
		VelocidadActual[Motor]=vel;
	}
}


void Servo360::Simultaneo(int VelDer,int VelIzq, int Duracion){
	float Diferencia0; float Diferencia1; float Diferencia2; float Diferencia3;
		//Serial.println("Afuera ");
	
	VelFinal[0]=VelDer; VelFinal[1]= -VelIzq;
	Aceleracion[0]=	(VelFinal[0]-VelocidadActualFloat[0])/Duracion/1000;
	Aceleracion[1]=	(VelFinal[1]-VelocidadActualFloat[1])/Duracion/1000;
	/*Serial.print("VelFinal[0] ");
	Serial.println(VelFinal[0]);
	Serial.print("VelocidadActualFloat[0] ");
	Serial.println(VelocidadActualFloat[0]);
	Serial.print("Aceleracion[0] ");
	Serial.println(Aceleracion[0]*100);*/

}

void Servo360::SimultaneoLoop(){
	VelocidadActualFloat[0]=VelocidadActualFloat[0]+ Aceleracion[0];
	VelocidadActualFloat[1]=VelocidadActualFloat[1]+ Aceleracion[1];	
	if(Aceleracion[0]>0){
		if(VelocidadActualFloat[0]>VelFinal[0]){
			Aceleracion[0]=0;
			VelocidadActualFloat[0]=VelFinal[0];
		}
	}
	if(Aceleracion[0]<0){
		if(VelocidadActualFloat[0]<VelFinal[0]){
			Aceleracion[0]=0;
			VelocidadActualFloat[0]=VelFinal[0];
		}
	}

	if(Aceleracion[1]>0){
		if(VelocidadActualFloat[1]>VelFinal[1]){
			Aceleracion[1]=0;
			VelocidadActualFloat[1]=VelFinal[1];
		}
	}
	if(Aceleracion[1]<0){
		if(VelocidadActualFloat[1]<VelFinal[1]){
			Aceleracion[1]=0;
			VelocidadActualFloat[1]=VelFinal[1];
		}
	}
	//Serial.print("VelocidadActualFloat[0] ");
	//Serial.println(VelocidadActualFloat[0]);
	//Serial.print("Aceleracion[0] ");
	//Serial.println(Aceleracion[0]);
/*

	if(PreVelDer != VelDer || PreVelIzq != VelIzq || PreDuracion != Duracion){
		PreVelDer = VelDer; PreVelIzq = VelIzq ;PreDuracion = Duracion;
		Serial.print("VelDer ");
		Serial.println(VelDer);
			//if(PasosSimultaneos<=0){
		//float Incremento0=1.0; float Incremento1=1.0;
		PasosSimultaneos=10.0;
		//float VelocidadActualFloat[2];
		VelocidadActualFloat[0]=VelocidadActual[0];
		VelocidadActualFloat[1]=VelocidadActual[1];
		if(VelDer< -100){VelDer= -100;}	if(VelDer>100){VelDer=100;}
		if(VelIzq< -100){VelIzq= -100;}	if(VelIzq>100){VelIzq=100;}
		VelDer=map(VelDer,-100,100,0,180);
		VelIzq=map(VelIzq,-100,100,0,180);
	
		if(Duracion<1.0){Duracion=1.0;}
		if(Duracion>10.0){Duracion=10.0;}
		//Duracion=map(Duracion,1.0,10.0,1.0,2.0);
		Diferencia0=VelDer-VelocidadActualFloat[0];Incremento0=Diferencia0/PasosSimultaneos;
		Diferencia1=VelIzq-VelocidadActualFloat[1];Incremento1=Diferencia1/PasosSimultaneos;
		RetardoSimultaneo=Duracion*1000/PasosSimultaneos;*/
	/*for(int i=0;i < PasosSimultaneos ; i++){
		sB[0].write(VelocidadActualFloat[0]);	
		sB[1].write(VelocidadActualFloat[1]);	
		VelocidadActualFloat[0] += Incremento0;
		VelocidadActualFloat[1] += Incremento1;
		
		
		delay(RetardoSimultaneo );
	}
	sB[0].write(VelDer);	
	sB[1].write(VelIzq);	
	VelocidadActual[0]=VelDer;
	VelocidadActual[1]=VelIzq;*/
	//}//}

//void Servo360::SimultaneoLoop(){
	//else{
		//Serial.print("PasosSimultaneos ");
		//Serial.println(PasosSimultaneos);
	//	PasosSimultaneos--;
	//	if (PasosSimultaneos>0){
			sB[0].write(convierte(VelocidadActualFloat[0]));	
			sB[1].write(convierte(VelocidadActualFloat[1]));	
	//		VelocidadActualFloat[0] += Incremento0;
	//		VelocidadActualFloat[1] += Incremento1;
	//		VelocidadActual[0]=VelocidadActualFloat[0];
	//		VelocidadActual[1]=VelocidadActualFloat[1];
			delay(RetardoSimultaneo );
		//}	
	//}
}
//Hacer que el servo siga marchando en el loop

void Servo360::Aleatorio(int VelMin,int VelMax){
	//float Diferencia0; float Diferencia1; float Diferencia2; float Diferencia3;
	//VelFinal[0]=VelDer; VelFinal[1]= -VelIzq;
	float Duracion=5;
	VelFinal[0]= -(random(VelMax)-VelMin); VelFinal[1]= (random(VelMax)-VelMin);
	Serial.print("VelFinal[0]");Serial.print(VelFinal[0]);Serial.print(" - VelFinal[1]");Serial.println(VelFinal[1]);
	Aceleracion[0]=	(VelFinal[0]-VelocidadActualFloat[0])/Duracion/1000;
	Aceleracion[1]=	(VelFinal[1]-VelocidadActualFloat[1])/Duracion/1000;
}

void Servo360::PegaLaVuelta(float Velocidad, float duracion){
	//float Diferencia0; float Diferencia1; float Diferencia2; float Diferencia3;
	//VelFinal[0]=0; VelFinal[1]= 0;
	//float Duracion=2.0;
	//Aceleracion[0]=	20/Duracion/1000;
	//Aceleracion[1]=	-20/Duracion/1000;
	//int Velocidad=30;
	Velocidad=convierte(Velocidad);
	//float Velocidad2=convierte(-Velocidad);
	if(duracion>10){duracion=10;}
	if(duracion<0){duracion=0.1;}
	sB[0].write(Velocidad);	
	sB[1].write(Velocidad);	
	delay(duracion*1000);
	sB[0].write(90);	
	sB[1].write(90);	

}



float convierte(float Velocidad){
	float signo= -1;
	//Serial.print("Velocidad ");
	//Serial.print(Velocidad);
	//Serial.print(" => ");
	if (Velocidad>0){signo=1;}
	Velocidad=abs(Velocidad);
	if(Velocidad>0){
		Velocidad=map(Velocidad,1,100,25,90);
		Velocidad=90+ Velocidad*signo;
	}else{
		Velocidad=90;
	}
	//Serial.println(Velocidad);
	return Velocidad  ;
}
		
int Servo360::obtenerVelocidad(int Motor){
	return VelocidadActual[Motor];
}